/*************************************************************************************
 *
 *    Define all the WindowObj stuff
 *
 *    WindowObj.h	-	C Headers
 *
 *	  Copyright  Apple Computer, Inc. 1988 - 1993
 *	  All rights reserved.
 *
 *    This defines the WindowObj class
 *
 *************************************************************************************/
#ifndef __WINDOWOBJ__
#define __WINDOWOBJ__

#include <Printing.h>

#define	ToWindowObj(it)		((WindowObj *)(((WindowPeek)(it))->refCon))
#define	WindowObjKind		'RT'	/*  Randy Thelen  */

class WindowObj {
public:
		WindowPtr	me;					// The standard "me"
		Boolean		useActivateClicks;	// Will the window drag if selected on the title bar?
		Boolean		dirtyFlag;		// Doess this individual window need to be saved?
		Handle		Scrap;			// Store the cut & copy stuff here
		Handle		UndoScrap;		// Store undo-able objects here
static	Boolean		isColor;		// Do WindowObjects have color?
		THPrint		myPrintInfo;	// Where are we printing this stuff?

public:
virtual void			InitObj( void);
virtual	Boolean			NewWindowObj( void);			//	Construct the entity, load rsrc's, etc.
virtual	Boolean			CloseWindowObj( void);			//	Deallocate the window
virtual	void			IdleObj( void);
virtual	void			AdjustMenusObj( void);
virtual	void			KeyPressObj( EventRecord *event);
virtual	void			MouseClickObj( EventRecord *event);
virtual	void			UpdateObj( void);
virtual	void			DrawObj( void);
virtual	void			PageSetupObj( void);
virtual	void			PrintObj( void);
virtual void			CutObj( EventRecord *event);
virtual void			CopyObj( EventRecord *event);
virtual void			PasteObj( EventRecord *event);
virtual void			UndoObj( EventRecord *event);
virtual void			DeleteObj( EventRecord *event);
virtual	void			DiskInsertObj( EventRecord *event);
virtual void			ConvertScrapObj( void);
virtual	void			ActivateObj( Boolean becomingActive);
virtual	void			MenuObj( short menu, short item, EventRecord *event);
virtual	void			AdjustCursorObj( Point mouseLoc, RgnHandle cursorRgn);
virtual	void			DrawGrowIconObj( void);
virtual void			DragWindowObj( EventRecord *event);
virtual void			GrowWindowObj( EventRecord *event);
virtual void			SetWindowTitle( Str255 *title);
virtual void			ZoomWindowObj( EventRecord *event, Boolean OutIsTrue);
virtual void			ScrollWindowObj( EventRecord *event);
virtual short int		DrawingWidth( void);
virtual short int		DrawingHeight( void);
virtual void			DrawingRect( Rect *area);
};

#endif


